inscriptions/urls.py
from django.urls import path
from . import views

app_name = 'inscriptions'
urlpatterns = [
    path('', views.index, name='index'),
    path('validation/', views.validation, name='validation'),
    path('save/', views.save, name='save'),
    path('reject/', views.reject, name='reject')
]

robopoly/urls.py
from django.conf import settings

from django.contrib import admin
from django.urls import include, path
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('inscriptions/', include('inscriptions.urls'))
]

inscriptions/models.py
from django.db import models
from django.utils import timezone

class Membre(models.Model):
    sciper = models.IntegerField(default=0)
    first_name = models.CharField(max_length=200, default="Pas de prénoms")
    name = models.CharField(max_length=200, default="Pas de noms")
    mail = models.CharField(max_length=200, default="Pas de mail")
    title = models.CharField(max_length=10, default="Pas de titre")
    section = models.CharField(max_length=50, default="Pas de section")
    phone_number = models.CharField(max_length=20, default="Pas de numéro")
    inscription_date_robopoly = models.DateTimeField(default=timezone.now)

inscriptions/views.py
from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect
from django.utils import timezone
from django.contrib.auth.models import User
from django.core import mail

from .models import Membre
from .person_finder import LDAP_get_infos

def index(request):
    if request.user.groups.filter(name = 'members of the committee').exists():
        return render(request, 'inscriptions/index.html')
    return HttpResponseRedirect('reject/')

def reject(request):
    return render(request, 'inscriptions/reject.html', {'not_connected_for_sure': 1})

def validation(request):
    sciper_is_known = 0
    try:
        sciper_is_known = int(request.POST['sciper_is_known'])
    except:
        sciper_is_known = 0

    sciper = 0
    first_name = ""
    name = ""
    mail = ""
    phone_number = ""
    gender = ""
    section = ""
    if sciper_is_known == 1:
        try:
            sciper = request.POST['sciper']
            infos = LDAP_get_infos(sciper)

            gender = "F"
            if infos[0] == "Monsieur":
                gender = "M"

            first_name, name, mail, section = infos[1], infos[2], infos[3], infos[4]

            # if we cannot retrieve the names, consider that LDAP fail
            if len(first_name) <= 0 or len(name) <= 0:
                raise("LDAP fail")
        except:
            sciper_is_known = 2
    
    try:
        phone_number = str(request.POST['phone_number'])
    except:
        phone_number = ""
    return render(  request,
                    'inscriptions/validation.html',
                    {
                        'sciper_is_known': sciper_is_known,
                        'sciper': sciper,
                        'first_name': first_name,
                        'name': name,
                        'mail': mail,
                        'phone_number': phone_number,
                        'gender': gender,
                        'section': section
                    }
                )

def save(request):
    inscription_status = 1
    mail_sending = 1
    descr_error = ''
    try:
        if not request.POST['sciper'].isnumeric():
            descr_error = 'le sciper n\'est pas une nombre: ' + request.POST['sciper']
            raise
        sciper = int(request.POST['sciper'])
        if sciper <= 0:
            descr_error = 'le sciper est invalide: sciper = ' + str(sciper)
            raise

        first_name = request.POST['first_name']
        if len(first_name) <= 0:
            descr_error = 'les prénoms sont invalides'
            raise

        name = request.POST['name']
        if len(name) <= 0:
            descr_error = 'le nom est invalide'
            raise

        mail = request.POST['mail']
        if len(mail) <= 0:
            descr_error = 'le mail est invalide'
            raise
        
        phone_number = request.POST['phone_number']
        if len(phone_number) <= 0:
            phone_number = '-'

        title = request.POST['gender']
        if title != 'Monsieur' and title != 'Madame':
            descr_error = 'ce genre ne convient pas à la base de données: ' + title
            raise

        section = request.POST['section']
        if len(section) <= 0:
            section = '-'

        print(sciper, first_name, name, mail, phone_number, title, section)
        new_member = Membre(sciper=sciper, first_name=first_name, name=name, mail=mail, phone_number=phone_number, title=title, section=section)
        new_member.save()
    except:
        if len(descr_error) <= 0:
            descr_error = 'sauvegarde impossible'
        inscription_status = 0
        mail_sending = 0
    
    if inscription_status == 1:
        try:
            subject = "sujet"
            message = """Madame, Monsieur,
C'est avec plaisir que nous avons l'avantage de vous parvenir la présente annonçant votre inscription pour la durée de l'actuelle année académique au sein de notre club: Robopoly.
Vous avez désormais accès à nos locaux, infrastructures et réseaux sociaux réservés aux membres. Notamment le local BM 9139 dont le code de la porte est 060898, notre channel Telegram et notre page Facebook
Afin d'assurer que ce club reste un lieu de rencontre et de partage si convivial, nous vous serons forts gré que vous preniez connaissance de notre règlement disponible sur notre site internet robopoly.epfl.ch et que vous le respectiez.
La situation actuelle, si particulière, nous contraint à diverses mesures de protection pour le bien commun. Aussi, nous vous demandons de bien vouloir respecter les mesures de distanciation et du port du masque. Vous êtes autorisé à venir sur campus, indifféremment du modulo d'identifiant SCIPER, dans nos infrastructures. Ceci ne vous donne en aucun cas un droit à une quelconque autre activité sur site.
C'est avec enthousiasme que nous vous accueillerons dans nos infrastructures, que nous répondront à vos éventuelles questions et requêtes par le biais de nos réseaux sociaux et, en attendant, nous vous présentons l'expression de nos salutations distinguées.
Le comité de Robopoly"""
            from_mail = "pierre.oppliger@robopoly.ch"
            to_mails = [mail]
            
            send_mail(subject, message, from_mail, to_mails)
        except:
            mail_sending = 0
    
    print(inscription_status)
    return render(request, 'inscriptions/save.html', {'inscription_status': inscription_status, 'mail_sending': mail_sending, 'descr_error': descr_error})

inscriptions/templates/inscriptions/base_inscription.html
{% load static %}

<html>
  <head>
    <title>Robopoly</title>
    <link rel="stylesheet" type="text/css" href="{% static 'inscriptions/style.css' %}">
  </head>

  <body>
    {% block content %}
    {% endblock %}
    
    {% if not_connected_for_sure != 1 %}
    <footer>
      <button onclick="location.href='{% url 'logout'%}';">
        Se déconnecter
      </button>
    </footer>
    {% endif %}
  </body>
</html>

inscriptions/templates/inscriptions/index.html
{% extends 'inscriptions/base_inscription.html' %}
{% block content %}
  <h1>Inscription d'un nouveau membre</h1>

  <p>
  <form class="" action="{% url 'inscriptions:validation' %}" method="post">
    {% csrf_token %}
    <table>
        <tr>
            <th><label for="sciper">Sciper:</label></th>
            <th><input type="number" id="sciper" name="sciper"></th>
        </tr>
        <tr>
            <th><label for="phone_number">Numéro tél.:</label></th>
            <th><input type="text" id="phone_number" name="phone_number"></th>
        </tr>
        <tr>
            <th></th>
            <th>
                <input type="hidden" name="sciper_is_known" value="1">
                <input type="submit" value="Rechercher">
            </th>
        </tr>
    </table>
   
    
    
  </form>
  </p>
  <p>
  <form class="" action="{% url 'inscriptions:validation' %}" method="post">
    {% csrf_token %}
    <label for="phone_number">Numéro tél.:</label>
    <input type="text" id="phone_number" name="phone_number">
    <input type="hidden" name="sciper_is_known" value="0">
    <input type="submit" value="Sans sciper">
  </form>
  </p>
{% endblock %}

inscriptions/templates/inscriptions/reject.html
{% extends 'inscriptions/base_inscription.html' %}
{% block content %}
  <p>
    Seuls les membres du comité Robopoly peuvent effectuer des inscriptions, et ce
    uniquement après l'octroi de droits spéciaux sur la présente application.<br />
    Si vous avez tel accès, vous pouvez vous connecter sans autre.
  </p>
  <p>
    <button onclick="location.href='{% url 'login'%}';">
      Se connecter
    </button>
  </p>
{% endblock %}

inscriptions/templates/inscriptions/save.html
{% extends 'inscriptions/base_inscription.html' %}
{% block content %}
  {% if inscription_status == 1 %}
    <div class="reussi">
      {% load static %}
      Inscription réussie !<br>
      <img class="robopoly_logo" src="{% static 'inscriptions/logo_anime_2.gif' %}" alt=""><br>
    </div>
  {% else %}
    <div class="echec">
      L'inscription n'a pas pu se faire en raison d'un problème :'-(<br>
      Erreur: {{ descr_error }}
    </div>
  {% endif %}
  {% if mail_sending == 1 %}
     <p class="mail_success">
         Un mail de bienvenue a été envoyé !
     </p>
  {% else %}
     <p class="mail_fail">
         Une erreur est survenue: il n'a pas été possible d'envoyer un mail de bienvenue.<br>
         Veuillez en envoyer un manuellement.
     </p>
  {% endif %}
  <form class="new_inscription" action="{% url 'inscriptions:index' %}" method="post">
    {% csrf_token %}
    <input type="submit" value="Nouvelle inscription">
  </form>
{% endblock %}

inscriptions/templates/inscriptions/validation.html
{% extends 'inscriptions/base_inscription.html' %}
{% block content %}
  {% if sciper_is_known != 2 and sciper_is_known != 1 and sciper_is_known != 0 %}
    Accès incorrect à cette page
  {% else %}
    {% if sciper_is_known == 2 %}
      Erreur de sciper
    {% else %}
      {% if sciper_is_known == 1 %}
        <h1>Vérification des données d'inscriptions</h1>
      {% else %}
        <h1>Entrée manuelle des données d'inscriptions</h1>
      {% endif %}

      <form action="{% url 'inscriptions:save' %}" method="post">
        {% csrf_token %}
        <div class="section_information">
          <label for="sciper">Sciper</label><br>
          {% if sciper_is_known == 1 %}
            <input type="text" name="sciper" id="sciper" value="{{sciper}}" readonly="readonly" readonly><br>
          {% else %}
            <input type="text" name="sciper" id="sciper" value="0"><br>
          {% endif %}
        </div>

        <div class="section_information">
          <label for="first_name">Prénoms</label><br>
          <input type="text" name="first_name" id="first_name" value="{% if sciper_is_known == 1 %}{{first_name}}{% endif %}" placeholder="Non renseigné"><br>
        </div>

        <div class="section_information">
          <label for="name">Nom</label><br>
          <input type="text" name="name" id="name" value="{% if sciper_is_known == 1 %}{{name}}{% endif %}" placeholder="Non renseigné"><br>
        </div>

        <div class="section_information">
          <label for="mail">Adresse e-mail</label><br>
          <input type="text" name="mail" id="mail" value="{% if sciper_is_known == 1 %}{{mail}}{% endif %}" placeholder="Non renseigné"><br>
        </div>
        
        <div class="section_information">
          <label for="phone_number">Numéro tél.</label><br>
          <input type="text" name="phone_number" id="phone_number" value="{% if sciper_is_known == 1 %}{{phone_number}}{% endif %}" placeholder="Non renseigné"><br>
        </div>

        <div class="section_information">
          <label for="title">Titre</label><br>
          <input type="radio" id="female" name="gender" value="Madame" {% if sciper_is_known != 1 or gender == 'F' %} checked {% endif %}>
          <label for="female">Madame</label><br>
          <input type="radio" id="male" name="gender" value="Monsieur" {% if sciper_is_known == 1 and gender == 'M' %} checked {% endif %}>
          <label for="male">Monsieur</label><br>
        </div>

        <div class="section_information">
          <label for="section">Section</label><br>
          <input type="text" name="section" id="section" value="{% if sciper_is_known == 1 %}{{section}}{% endif %}" placeholder="Non renseigné"><br>
          <br>
        </div>

        <input type="submit" value="Inscrire">
      </form>
    {% endif %}
  {% endif %}
{% endblock %}